#ifndef __CartesianCell_h__
#define __CartesianCell_h__

#include <vector>

class CartesianCell {
 public:
  virtual ~CartesianCell() {}
  CartesianCell(int row, int col);
  bool operator==(const CartesianCell& other) const;

  bool isLinked(CartesianCell* cell) const;
  void link(CartesianCell* cell, bool bidir = true);
  void unlink(CartesianCell* cell, bool bidir = true);

  int row();
  int col();

  void north(CartesianCell* cell);
  void east(CartesianCell* cell);
  void south(CartesianCell* cell);
  void west(CartesianCell* cell);
  CartesianCell* north();
  CartesianCell* east();
  CartesianCell* south();
  CartesianCell* west();

 private:
  int mrow, mcol;
  std::vector<CartesianCell*> mlinks;
  std::vector<CartesianCell*> mneighbors;
};

#endif