#ifndef __CartesianGrid_h__
#define __CartesianGrid_h__

#include <vector>

#include "CartesianCell.h"

class CartesianGrid {
 public:
  virtual ~CartesianGrid();
  CartesianGrid(int rows, int cols);
  CartesianCell* getCell(int row, int col) const;
  CartesianCell* operator()(int row, int col) const;
  void foreachRow(std::function<void(std::vector<CartesianCell*>)> rowFunction);
  void foreachCell(std::function<void(CartesianCell*)> cellFunction);
  void forRandomCell(std::function<void(CartesianCell*)> cellFunction);
  friend std::ostream& operator<<(std::ostream& out, const CartesianGrid& grid);

 private:
  int mrows, mcols;
  std::vector<std::vector<CartesianCell*>> mcells;
  std::function<int()> mrandomRow, mrandomCol;
};

#endif